searchNodes=[{"doc":"Prepares and runs static analysis of application code via dialyzer.PLT CreationFor efficiency, we construct multiple PLTs: one for Erlang and the runtime system (ERTS), one for Elixir, and one for the transitive dependencies of the project. The rationale here is that the Erlang installation, Elixir installation, and the dependencies of the project have different lifetimes. Erlang and Elixir, for example, would not change across builds of the same project, but a dependency might. Additionally, analyzing the standard library in order to construct a PLT is expensive and should be done infrequently.By default, Erlang and Elixir PLTs are stored in a hidden subdirectory of the user's home directory, namely ~/.cache/dialyzer/plts. The contents of that directory after building PLTs might look like the below:$ ls ~/.cache/dialyzer/plts/ elixir-1.6.1-erlang-20-erts-9.2.plt erlang-20-erts-9.2.pltYou can change where Erlang and Elixir PLTs are stored using the :dialyzer_cache_directory config key in the Mix project configuration. Setting the key to nil will make dialyzex use the default directory, so you can easily configure it based on the Mix.env()def project do [ ... dialyzer_cache_directory: dialyzer_cache_directory(Mix.env()), ... ] end defp dialyzer_cache_directory(:ci) do &quot;.cache&quot; end defp dialyzer_cache_directory(_) do nil endThe dependencies PLT is stored in the build directory of the current Mix.env, e.g. _build/dev/deps-N0rJXDclQ8d-ibrpSc_emw.plt.WarningsAll non-default recommended warnings are turned on, equivalent to these command-line flags to dialyzer:-Wunmatched_returns -Werror_handling -Wrace_conditions -Wunderspecs -WunknownWarnings can be customized using the :dialyzer_warnings config key in the Mix project configuration.If warnings are emitted from analysis, the task will exit non-zero. In some cases, there are particular warning signatures that are acceptable and should not cause failure of an automated build. These signatures can be matched and ignored via the :dialyzer_ignored_warnings setting. The format of this list are match patterns of the warning tuples produced by dialyzer:{tag, {file, line}, {warning_type, arguments}}The warning tuples coming from your analysis can be printed by turning debug mode on:$ MIX_DEBUG=1 mix dialyzer --check=false # [snip] Running analysis... Errors: ct.ex:177: The created fun only terminates with explicit exception dialyzer.ex:282: The created fun only terminates with explicit exception IGNORED WARNINGS: [] FAILURES: [{:warn_return_only_exit, {&#39;lib/mix/tasks/ct.ex&#39;, 177}, {:no_return, [:only_explicit]}}, {:warn_return_only_exit, {&#39;lib/mix/tasks/dialyzer.ex&#39;, 282}, {:no_return, [:only_explicit]}}] FAILURE: 2 failures.From those tuples, you can determine how to construct the match pattern. If one wanted to ignore the first failure, the following pattern would work:{:warn_return_only_exit, {&#39;lib/mix/tasks/ct.ex&#39;, :_}, {:no_return, :_}}For fields of the tuple that aren't important to distinguish, use :_ to match all patterns in that space. See OTP's documentation on match patterns and specs for more details.Running analysis for specific filesYou can limit the analysis to just specific files by specifying a :dialyzer_analysed_files option under your project's mix config. It expects a function of type (-&gt; [String.t]) that returns a list of .beam files to be analysed.Please note that this option makes no assumptions about consolidated protocols, so if you get warnings regarding missing implementations for protocols you probably need to add that protocol's consolidated .beam file (which is usually found under _build/\#{env}/consolidated) to the list of analysed files.Options--check=(true|false): enable/disable checking of existing PLTs (default: true)--compile=(true|false): enable/disable compilation of the project (default: true)CaveatsIf checking an existing PLT fails (e.g. a dependency changed), you must remove the PLT to force a rebuild. This caveat is mitigated for the shared PLTs by naming them after their respective versions, which are assumed to be stable, and the dependency PLT after the hash of the lockfile contents (somewhat). In future versions, we could add or remove information from the PLTs as needed.","ref":"Mix.Tasks.Dialyzer.html","title":"Mix.Tasks.Dialyzer","type":"task"},{"doc":"Cleans up PLTs that were generated by the dialyzer task. By default, only PLTs in the current project are removed.Options--all: Remove the Erlang/OTP and Elixir PLTs in addition to the project PLT(s).","ref":"Mix.Tasks.Dialyzer.Clean.html","title":"Mix.Tasks.Dialyzer.Clean","type":"task"},{"doc":"dialyzexThis project adds a mix dialyzer task to your project. In addition to simply automating dialyzer for Elixir projects, it provides some features that existing solutions may not:Layered construction and validation of global PLTs for Erlang/OTP, Elixir, and a local PLT for project dependencies.Friendly ANSI-colored output.Exits non-zero when dialyzer produces warnings (good for continuous integration usage).Defaults to the strictest set of warnings available in Dialyzer, except for the few that are overly expensive.Ability to ignore acceptable warnings based on match patterns. For example, to ignore warnings produced by protocol compilation:# Ignore dialyzer warnings about compiler generated specs for Protocols {:warn_contract_supertype, :_, {:extra_range, [:_, :__protocol__, 1, :_, :_]}}For more details, consult mix help dialyzer after installation.","ref":"readme.html","title":"dialyzex","type":"extras"},{"doc":"dialyzex is available for installation from Hex. The package can be installed by adding dialyzex to your list of dependencies in mix.exs: def deps do [ {:dialyzex, &quot;~&gt; 1.2.0&quot;, only: :dev} ] end","ref":"readme.html#installation","title":"dialyzex - Installation","type":"extras"},{"doc":"Documentation is generated with ExDoc and published on HexDocs at https://hexdocs.pm/dialyzex.","ref":"readme.html#documentation","title":"dialyzex - Documentation","type":"extras"},{"doc":"If you would like to contribute code to this project you can do so through GitHub by forking the repository and sending a pull request. Before Comcast merges your code into the project you must sign the Comcast Contributor License Agreement (CLA). If you haven't previously signed a Comcast CLA, you'll automatically be asked to when you open a pull request. Alternatively, we can e-mail you a PDF that you can sign and scan back to us. Please send us an e-mail or create a new GitHub issue to request a PDF version of the CLA.","ref":"readme.html#contributing","title":"dialyzex - Contributing","type":"extras"},{"doc":"Copyright 2017 Comcast Cable Communications Management, LLCLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.This product includes software developed at Comcast (http://www.comcast.com/).","ref":"readme.html#copyright-license","title":"dialyzex - Copyright &amp; License","type":"extras"}]